package in.techware.carrefour.dbUtils.dao;

import android.arch.persistence.room.Dao;
import android.arch.persistence.room.Delete;
import android.arch.persistence.room.Insert;
import android.arch.persistence.room.OnConflictStrategy;
import android.arch.persistence.room.Query;
import android.arch.persistence.room.Update;

import java.util.List;

import in.techware.carrefour.dbUtils.entity.WasteEntity;


/**
 * Created by Jemsheer K D on 25 July, 2018.
 * Package in.techware.carrefour.dbUtils.dao
 * Project Carrefour
 */

@Dao
public interface WasteDao {

    @Query("SELECT * FROM waste")
    List<WasteEntity> loadAllWastes();

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void insertAll(List<WasteEntity> wasteEntityList);


    @Query("select * from waste where id = :id ORDER BY id DESC LIMIT 1")
    List<WasteEntity> getWaste(String id);

    @Query("select * from waste where sendStatus = 0 ORDER BY id")
    List<WasteEntity> getAllUnsentWaste();

    @Query("select * from waste where sendStatus = 1 ORDER BY id")
    List<WasteEntity> getAllSentWaste();

    @Query("DELETE from waste where sendStatus = 0")
    void deleteAllUnsentWaste();

    @Query("DELETE from waste where sendStatus = 1")
    void deleteAllSentWaste();

    @Query("DELETE FROM waste")
    void deleteAll();

    @Insert
    long insert(WasteEntity wasteEntity);

    @Update
    void update(WasteEntity wasteEntity);

    @Delete
    void delete(WasteEntity wasteEntity);
}
